> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/ios/basic-operations/saving.md).

# Saving documents on iOS

Learn how to save PDF documents using PDFNet saving APIs from PTPDFDoc class. Explore different saving modes like removing unused objects, incremental saving, and linearized format for optimized stora

Use PDFNet saving APIs from [`PTPDFDoc`](https://sdk.apryse.com/api/ios/Classes/PTPDFDoc.html) class to save PDF documents on local storage.

## Save by path

To save a PDF document to path use [`(void)SaveToFile:(NSString *)path flags:(unsigned int)flags`](https://sdk.apryse.com/api/ios/Classes/PTPDFDoc.html#/c:objc\(cs\)PTPDFDoc\(im\)SaveToFile:flags:):

{% tabs %}
{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
[pdfDoc Lock];
[pdfDoc SaveToFile:docPath flags:0];
[pdfDoc Unlock];
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Saving modes

There are a few ways to save a PDF document on permanent storage such as save with remove unused objects, save incrementally, and save in linearized format. See complete [list of saving modes](https://sdk.apryse.com/api/ios/Enums/PTSaveOptions.html).

### Save with remove unused objects ([`REMOVE_UNUSED`](https://sdk.apryse.com/api/ios/Enums/PTSaveOptions.html#/c:@E@PTSaveOptions@e_ptremove_unused))

This mode is optimized in terms of storage volume as it rearranges the PDF document and removes unused objects. As a result, the output file may be improved in terms of rendering too, although the saving process itself may take longer compared to other modes.

### Save incrementally ([`INCREMENTAL`](https://sdk.apryse.com/api/ios/Enums/PTSaveOptions.html#/c:@E@PTSaveOptions@e_ptincremental))

Use the incremental mode if you are concerned about saving time. If you use this mode, any changes to the document, even deleting annotations, will result in appending to the PDF file. Note that it is not possible to incrementally save the document if the underlying file has an XRef table that had to be repaired when the file was opened (see <https://groups.google.com/forum/#!msg/pdfnet-sdk/GZwt_U16ipw/zhq43GQnNlYJ>).

### Save in linearized format ([`LINEARIZED`](https://sdk.apryse.com/api/ios/Enums/PTSaveOptions.html#/c:@E@PTSaveOptions@e_ptlinearized))

The linearized format is preferred for file streaming situations, such as when you want to upload a PDF document. A linearized PDF file is a PDF file that is structured in a way that allows the first page of the PDF file to be displayed in a user's device before the entire file is downloaded from the Web server. If you're developing a system that creates large PDF files for delivery to client, you should try to make sure that your system can generate linearized PDF files. Your users might become frustrated and impatient if your system creates large PDF files that are not linearized, because it could take 30 seconds or even longer for a user's device to display a large PDF file that is not linearized. PDF linearization is also know as 'fast web view'.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/ios/basic-operations/saving.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
